/* This file is part of the uLisp-TFT program
   Copyright (C) 2018  Christopher Howard

   uLisp-TFT is free software: you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   uLisp-TFT is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

object *fn_lcdinit (object *args, object *env) {
  (void) env;
  pinMode(A0, OUTPUT);       //.kbv mcufriend have RD on A0
  digitalWrite(A0, HIGH);
  
  // Setup the LCD
  glcd.InitLCD();
  glcd.setFont(SmallFont);
  return nil;
}

object *fn_setcolor (object *args, object *env) {
  (void) env;
  glcd.setColor(integer(first(args)),
                integer(second(args)),
                integer(car(cdr(cdr(args)))));
  return nil;
}

object *fn_fillrect (object *args, object *env) {
  (void) env;
  glcd.fillRect(integer(first(args)),
                integer(second(args)),
                integer(car(cdr(cdr(args)))),
                integer(car(cdr(cdr(cdr(args))))));
  return nil;
}

object *fn_clrscr (object *args, object *env) {
  (void) env;
  glcd.clrScr();
  return nil;
}

object *fn_drawpixel (object *args, object *env) {
  (void) env;
  glcd.drawPixel(integer(first(args)),
                 integer(second(args)));
  return nil;
}

object *fn_drawline (object *args, object *env) {
  (void) env;
  glcd.drawLine(integer(first(args)),
                integer(second(args)),
                integer(car(cdr(cdr(args)))),
                integer(car(cdr(cdr(cdr(args))))));
  return nil;
}

object *fn_fillscr (object *args, object *env) {
  (void) env;
  glcd.fillScr(integer(first(args)),
               integer(second(args)),
               integer(car(cdr(cdr(args)))));
  return nil;
}

object *fn_drawrect (object *args, object *env) {
  (void) env;
  glcd.drawRect(integer(first(args)),
                integer(second(args)),
                integer(car(cdr(cdr(args)))),
                integer(car(cdr(cdr(cdr(args))))));
  return nil;
}

const char string155[] PROGMEM = "lcdinit";
const char string156[] PROGMEM = "setcolor";
const char string157[] PROGMEM = "fillrect";
const char string158[] PROGMEM = "clrscr";
const char string159[] PROGMEM = "drawpixel";
const char string160[] PROGMEM = "drawline";
const char string161[] PROGMEM = "fillscr";
const char string162[] PROGMEM = "drawrect";
